mod\_env

Modifies the environment which is passed to CGI scripts and SSI pages

Base

mod\_env.c

env\_module

This module allows for control of internal environment variables that
are used by various Apache HTTP Server modules. These variables are also
provided to CGI scripts as native system environment variables, and
available for use in SSI pages. Environment variables may be passed from
the shell which invoked the

httpd

process. Alternatively, environment variables may be set or unset within
the configuration process.

Environment Variables

SetEnvIf

PassEnv

Passes environment variables from the shell

PassEnv

env-variable

\[

env-variable

\] \...

server config

virtual host

directory

.htaccess

FileInfo

Specifies one or more native system environment variables to make
available as internal environment variables, which are available to
Apache HTTP Server modules as well as propagated to CGI scripts and SSI
pages. Values come from the native OS environment of the shell which
invoked the

httpd

process.

PassEnv LD\_LIBRARY\_PATH

SetEnv

Sets environment variables

SetEnv

env-variable

\[

value

\]

server config

virtual host

directory

.htaccess

FileInfo

Sets an internal environment variable, which is then available to Apache
HTTP Server modules, and passed on to CGI scripts and SSI pages.

SetEnv SPECIAL\_PATH /foo/bin

If you omit the

value

argument, the variable is set to an empty string.

> **Note**
>
> The internal environment variables set by this directive are set
>
> after
>
> most early request processing directives are run, such as access
> control and URI-to-filename mapping. If the environment variable
> you\'re setting is meant as input into this early phase of processing
> such as the
>
> RewriteRule
>
> directive, you should instead set the environment variable with
>
> SetEnvIf
>
> .

Environment Variables

UnsetEnv

Removes variables from the environment

UnsetEnv

env-variable

\[

env-variable

\] \...

server config

virtual host

directory

.htaccess

FileInfo

Removes one or more internal environment variables from those passed on
to CGI scripts and SSI pages.

UnsetEnv LD\_LIBRARY\_PATH
