mod\_example\_hooks

Illustrates the Apache module API

Experimental

mod\_example\_hooks.c

example\_hooks\_module

The files in the

modules/examples

directory under the Apache distribution directory tree are provided as
an example to those that wish to write modules that use the Apache API.

The main file is

mod\_example\_hooks.c

, which illustrates all the different callback mechanisms and call
syntaxes. By no means does an add-on module need to include routines for
all of the callbacks - quite the contrary!

The example module is an actual working module. If you link it into your
server, enable the \"example-hooks-handler\" handler for a location, and
then browse to that location, you will see a display of some of the
tracing the example module did as the various callbacks were made.

Compiling the example\_hooks module {#compiling}
===================================

To include the example\_hooks module in your server, follow the steps
below:

Run

configure

with

\--enable-example-hooks

option.

Make the server (run \"

make

\").

To add another module of your own:

cp modules/examples/mod\_example\_hooks.c modules/new\_module/

mod\_myexample.c

Modify the file.

Create

modules/new\_module/config.m4

.

Add

APACHE\_MODPATH\_INIT(new\_module)

.

Copy APACHE\_MODULE line with \"example\_hooks\" from

modules/examples/config.m4

.

Replace the first argument \"example\_hooks\" with

myexample

.

Replace the second argument with brief description of your module. It
will be used in

configure \--help

.

If your module needs additional C compiler flags, linker flags or
libraries, add them to CFLAGS, LDFLAGS and LIBS accordingly. See other

config.m4

files in modules directory for examples.

Add

APACHE\_MODPATH\_FINISH

.

Create

module/new\_module/Makefile.in

. If your module doesn\'t need special build instructions, all you need
to have in that file is

include \$(top\_srcdir)/build/special.mk

.

Run ./buildconf from the top-level directory.

Build the server with \--enable-myexample

Using the `mod_example_hooks` Module {#using}
====================================

To activate the example\_hooks module, include a block similar to the
following in your

httpd.conf

file:

\<Location \"/example-hooks-info\"\> SetHandler example-hooks-handler
\</Location\>

As an alternative, you can put the following into a

.htaccess

file and then request the file \"test.example\" from that location:

AddHandler example-hooks-handler .example

After reloading/restarting your server, you should be able to browse to
this location and see the brief display mentioned earlier.

Example

Demonstration directive to illustrate the Apache module API

Example

server config

virtual host

directory

.htaccess

Options

The

Example

directive just sets a demonstration flag which the example module\'s
content handler displays. It takes no arguments. If you browse to an URL
to which the example-hooks content-handler applies, you will get a
display of the routines within the module and how and in what order they
were called to service the document request. The effect of this
directive one can observe under the point \"

Example directive declared here: YES/NO

\".
